// #autoload
// #name = IRCTimeStamper
// #version = 1.1
// #date = December 16, 2001
// #author = <T>base10
// #warrior =  base10
// #email = templar@base10.org
// #web = http://base10.org/t2scripts/
// #description = Timestamps messages in the IRC window, provides a game clock, and allows special chars (%:<>\) in chat.
// #status = release
// #readme = scripts/base10/irctimestamp.txt
// #config = IRCTimeStamperOptionsGui
// #include = self
// #include = scripts/base10/gui/IRCTimeStamperOptionsGui.gui
// #include = scripts/base10/gui/IRCTimeStamp.gui
// #credit = DeadManWalking - I borrowed quite a bit from his options dialog in DMWChat.  Didn't take any code tho.
// #credit = <T>Variable - for being my enthusiastic tester and providing some new ideas on options.


$TimeStamperDebug = false;
package IRCTimeStamper {
	
	// overrides first
	function IRCClient::newMessage(%channel,%message) {
		if($pref::IRCTimeStamper::EnableStamp == 1) {
			if ($TimeStamperDebug) {
				echo("--------");
				echo("IRC message packet has arrived.");
				echo("Channel: " @ %channel);
				echo("Message text: " @ %message);
				echo("--------");
			}
			
			%stamp = IRCTimeStamperGui.GetStamp();
			%message = "[" @ %stamp @ "]:" @ %message;
		}
		parent::newMessage(%channel,%message);
	}
	// just hafta override their send function in order to bypass char checks
	function ChatSendText()
	{
		TextCheck2(ChatMessageEntry.getValue(),ChatMessageEntry);
		
		if(!IRCTimeStamperGui.CheckMessage())
		{
	         for(%x=0;%x<getField($I,0);%x++)
	         {
	            %msgStr = %msgStr @ getField($strcheck2,1+%x) @ " ";
	         }
	         MessageBoxOK("NOTICE","You must enable special characters in the IRCTimeStamper options GUI to send special characters.");
			ChatMessageEntry.makeFirstResponder(1);
		}
		else
		{
	
		   if ($IRCClient::people.getObject(0).flags & $PERSON_AWAY)
		      IRCClient::away("");
		   else
		   {
		      if ($IRCClient::awaytimeout)
		         cancel($IRCClient::awaytimeout);
		      $IRCClient::awaytimeout = schedule($AWAY_TIMEOUT,0,"ChatAway_Timeout");
		   }
		   if ($IRCClient::currentChannel.private)
		      IRCClient::send2(ChatMessageEntry.getValue(),$IRCClient::currentChannel.getName());
		   else
		      IRCClient::send2(ChatMessageEntry.getValue(),"");
		   ChatMessageEntry.setValue("");
		}
	}

	function IRCTimeStamperGui::CheckMessage(%msg) {
		if($pref::IRCTimeStamper::EnableSpecial == 1) {
			return true;
		} else {
			TextCheck2(ChatMessageEntry.getValue(),ChatMessageEntry);
			if(ChatMessageEntry.textCheck) {
				return false;
			} else {
				return true;
			}
		}
	}

	function IRCTimeStamperGui::GetStamp(%this) {
		if($pref::IRCTimeStamper::UsePJ == 1) {
			// get stamp from pj
			if (IsObject(TimeHUD)) {
				// get stamp from PJ, if user has it.
				return $PJHour @ ":" @ $PJMinute @ ":" @ $PJSecond @ " " @ $PJampm;
			} else {
				// turn off pref for PJ, since user doesn't have it.
				$pref::IRCTimeStamper::UsePJ = 0;
			}
		} else if ($pref::IRCTimeStamper::UseTwo == 1) {
			if (IsObject(TwoTimeObj)) {
				// get stamp from TwoTime, if user has it
				TwoTimeObj.GetCurrentTime("1", "1");
			} else {
				// turn off pref for Two's script, since user doesn't have it.
				$pref::IRCTimeStamper::UseTwo = 0;
			}
		} else {
			// use my time formatter, from our seconds counter.
			%seconds = $IRCTimeStamperGui_seconds;
			%seconds++;%seconds--;
			%minutes =  %this.integer(%seconds / 60);
			%hours =  %this.integer(%minutes / 60);
			%seconds = %seconds - (%minutes * 60); //kinda does a modulus?
			%minutes = %minutes - (%hours * 60);
			
			if(%seconds < 10) {
				%seconds = "0" @ %seconds;
			}
			if(%minutes < 10) {
				%minutes = "0" @ %minutes;
			}
			if(%hours < 10) {
				%hours = "0" @ %hours;
			}
			
			return %hours @ ":" @ %minutes @ ":" @ %seconds;
		}
	}
	
	function IRCTimeStamperGui::integer(%this,%number) {
		// cheater function to get an integer from a float
		%pos = strpos(%number, ".");
		if(%pos > 0) {
			%newnumber = getSubStr(%number,0,%pos);
			return %newnumber;
		} else {
			return %number;
		}
	}

	function IRCTimeStamperGui::init(%this) {
		if($IRCTimeStamperGui_running != 1) {
			ChatChannelPane.add(IRCTimeStamperGui);
			$IRCTimeStamperGui_seconds = 0;
			$IRCTimeStamperGui_running = 1;
			IRCTimeStamperGui_ping();
			if ($TimeStamperDebug) {
				echo("Initted and did first ping.  Sec is set at " @ $IRCTimeStamperGui_seconds);
			}
		}
	}
	
	function IRCTimeStamperGui::UpdateClock(%this) {
		if(IRCTimeStamperGui.isAwake() == 1) {
			if($pref::IRCTimeStamper::EnableClock == 1) { 
				IRCTimeStamperGui.setText("Time online: " @ IRCTimeStamperGui.GetStamp());
			}
		}
	}
	
	function IRCTimeStamperGui::DetermineTime(%this) {
		// my method of determining time: create a file and get the timestamp. :)
		
		%fh = new FileObject();
		%fh.openForWrite("prefs/dummyIRCT.txt");
		%fh.writeLine("//dummy");
		%fh.close();
		%fh.delete();
		
		%file = findFirstFile("prefs/dummyIRCT.txt");
		%fileTime = getFileModifyTime(%file);
		
		deleteFile("prefs/dummyIRCT.txt");
		echo("Time and date is " @ %fileTime);
	}
	
	function IRCTimeStamperGui_ping() {
		schedule(1000,0,IRCTimeStamperGui_ping); // do this first so we don't incur lag from other functions
		// increment our seconds counter
		$IRCTimeStamperGui_seconds++;
		// update the online clock, if visible.
		IRCTimeStamperGui.UpdateClock();
		if ($TimeStamperDebug) {
			echo("Received a IRC clockping: " @ $IRCTimeStamperGui_seconds);
		}
	}
};

activatepackage(IRCTimeStamper);
